//lksp.cs

//projectile
AddDamageType("lksp",   '<bitmap:add-ons/Weapon_Legoknights/CI_lksp> %1',    '%2 <bitmap:add-ons/Weapon_Legoknights/CI_lksp> %1',0.75,1);
AddDamageType("lkspcharge",   '<bitmap:add-ons/Weapon_Legoknights/CI_lkspcharge> %1',    '%2 <bitmap:add-ons/Weapon_Legoknights/CI_lkspcharge> %1',0.75,1);
datablock ProjectileData(lkspProjectile)
{
   directDamage        = 40;
   directDamageType  = $DamageType::lksp;
   radiusDamageType  = $DamageType::lksp;
   explosion           = swordExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ProjectileData(lkspchargeProjectile)
{
   directDamage        = 90;
   directDamageType  = $DamageType::lkspcharge;
   radiusDamageType  = $DamageType::lkspcharge;
   explosion           = spearExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ItemData(lkspItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./lksp.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Spear";
	iconName = "./icon_lksp";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = lkspImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lkspImage)
{
   // Basic Item properties
   shapeFile = "./lksp.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lkspItem;
   ammo = " ";
   projectile = lkspProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Chargeopt";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "StopFire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";

	stateName[6]                    = "Charge";
	stateTransitionOnTimeout[6]	= "Armed";
	stateTimeoutValue[6]            = 0.7;
	stateWaitForTimeout[6]		= false;
	stateTransitionOnTriggerUp[6]	= "AbortCharge";
	stateScript[6]                  = "onCharge";
	stateAllowImageChange[6]        = false;
	
	stateName[7]			= "AbortCharge";
	stateTransitionOnTimeout[7]	= "Ready";
	stateTimeoutValue[7]		= 0.3;
	stateWaitForTimeout[7]		= true;
	stateScript[7]			= "onAbortCharge";
	stateAllowImageChange[7]	= false;

	stateName[8]			= "Armed";
	stateTransitionOnTriggerUp[8]	= "ChargedFire";
	stateAllowImageChange[8]	= false;

	stateName[9]			= "ChargedFire";
	stateTransitionOnTimeout[9]	= "Ready";
	stateTimeoutValue[9]		= 0.5;
	stateFire[9]			= true;
	stateSequence[9]		= "fire";
	stateScript[9]			= "onChargedFire";
	stateWaitForTimeout[9]		= true;
	stateAllowImageChange[9]	= false;

	stateName[10]			= "Chargeopt";
	stateAllowImageChange[10]        = false;
	stateTimeoutValue[10]            = 0.3;
	stateTransitionOnTimeout[10]     = "Charge";
	stateTransitionOnTriggerUp[10]	= "PreFire";

};

function lkspImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function lkspImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function lkspImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function lkspImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function lkspImage::onChargedFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
	%obj.playThread(2, spearThrow);

	%projectile = lkspchargeProjectile;
	%spread = 0.0;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = lkspchargeProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}